View Javadoc

    1   /*
    2    * Copyright 2009 Red Hat, Inc.
    3    *
    4    * Red Hat licenses this file to you under the Apache License, version 2.0
    5    * (the "License"); you may not use this file except in compliance with the
    6    * License.  You may obtain a copy of the License at:
    7    *
    8    *    http://www.apache.org/licenses/LICENSE-2.0
    9    *
    10   * Unless required by applicable law or agreed to in writing, software
    11   * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
    12   * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
    13   * License for the specific language governing permissions and limitations
    14   * under the License.
    15   */
    16  package org.jboss.netty.util;
    17
    18  import java.util.Set;
    19  import java.util.concurrent.TimeUnit;
    20
    21  /**
    22   * Schedules {@link TimerTask}s for one-time future execution in a background
    23   * thread.
    24   *
    25   * @author <a href="http://www.jboss.org/netty/">The Netty Project</a>
    26   * @author <a href="http://gleamynode.net/">Trustin Lee</a>
    27   * @version $Rev: 2080 $, $Date: 2010-01-26 18:04:19 +0900 (Tue, 26 Jan 2010) $
    28   *
    29   * @apiviz.landmark
    30   * @apiviz.has org.jboss.netty.util.TimerTask oneway - - executes
    31   * @apiviz.has org.jboss.netty.util.Timeout oneway - - creates
    32   */
    33  public interface Timer {
    34
    35      /**
    36       * Schedules the specified {@link TimerTask} for one-time execution after
    37       * the specified delay.
    38       *
    39       * @return a handle which is associated with the specified task
    40       *
    41       * @throws IllegalStateException if this timer has been
    42       *                               {@linkplain #stop() stopped} already
    43       */
    44      Timeout newTimeout(TimerTask task, long delay, TimeUnit unit);
    45
    46      /**
    47       * Releases all resources acquired by this {@link Timer} and cancels all
    48       * tasks which were scheduled but not executed yet.
    49       *
    50       * @return the handles associated with the tasks which were canceled by
    51       *         this method
    52       */
    53      Set<Timeout> stop();
    54  }